"use strict";
import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker, Modal, Upload ,Popconfirm} from 'antd';
import MySettlementDetaile from "./mySettlementDetaile.jsx";
import moment from 'moment';
import '../../userMangagement.less';
import {paymentState ,orderChannel} from '../../../../dataDic.js';
import {getProjectState,getOrderChannel,getOrderType,getOrderState,getPaymentState} from '../../../../tools.js';

const MySettlement=Form.create()(React.createClass({
	loadData(pageNo,depart) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/listMySettlement',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                buyerName:this.state.buyerNameSearch,
                depId:this.state.departmenttSearch,//部门
                salesmanName:this.state.salesmanNameSearch,//负责人
                startDate: this.state.releaseDate[0],
				endDate: this.state.releaseDate[1],
				liquidationStatus:this.state.liquidationStatusSearch, //结算
				approval:this.state.orderChannelSearch,//特批
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         orderNo: thisdata.orderNo,//订单编号
	                         orderType:thisdata.orderType,//订单类型
	                         orderStatus:thisdata.orderStatus,
	                         liquidationStatus:thisdata.liquidationStatus,
	                         createTime:thisdata.createTime,
	                         buyerName:thisdata.buyerName,
	                         signTotalAmount:thisdata.signTotalAmount,
	                         projectStage:thisdata.projectStage,
	                         approval:thisdata.approval,
	                         orderChannel:thisdata.orderChannel,
	                         salesmanName:thisdata.salesmanName,
	                         active:thisdata.active,
	                         departmentName:thisdata.departmentName,
	                         salesmanName:thisdata.salesmanName,
	                         financeName:thisdata.financeName,
	                         technicianName:thisdata.technicianName,
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                	pageNo:pageNo,
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[],
                    signBillVisible:false
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    //部门
	departmentList() {
		this.setState({
			loading: true
		});
		$.ajax({
			method: "post",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context + "/api/admin/organization/selectSuperId",
			data: {
				
			},
			success: function(data) {
				let thedata = data.data;
				let theArr=[];
				if(!thedata) {
					if(data.error && data.error.length) {
						message.warning(data.error[0].message);
					};
					thedata = {};
				}else{
					thedata.map(function(item,index){
						theArr.push({
							key:index,
							name:item.name,
							id:item.id,
						})
					})
				}
				this.setState({
					departmentArr:theArr,
				})
				this.loadData('1',theArr);
			}.bind(this),
			}).always(function() {
				this.setState({
					loading: false
				});
			}.bind(this));
	},
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            releaseDate: [],
            departmentArr:[],
            selectedRows: [],
            searchMore: true,
            loading: false,
            visible:false,
            showDesc:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'orderNo',
                    key: 'orderNo'
                }, {
                    title: '订单类型',
                    dataIndex: 'orderType',
                    key: 'orderType',
                    render:text=>{return getOrderType(text)}
                }, {
                    title: '下单时间',
                    dataIndex: 'createTime',
                    key: 'createTime'
                },{
                    title: '订单客户',
                    dataIndex: 'buyerName',
                    key: 'buyerName',
                    render:(text)=>{
                    	return (text.length>9?text.substr(0,9)+'...':text)
                    }
                }, {
                    title: '实际下单金额',
                    dataIndex: 'signTotalAmount',
                    key: 'signTotalAmount'
                }, {
                    title: '订单状态',
                    dataIndex: 'orderStatus',
                    key: 'orderStatus',
                    render:(text)=>{return getOrderState(text) }
                },{
                    title: '项目进度',
                    dataIndex: 'projectStage',
                    key: 'projectStage',
                    render:(text)=>{return getProjectState(text) }
                }, {
                    title: '结算状态',
                    dataIndex: 'liquidationStatus',
                    key: 'liquidationStatus',
                    render:text=>{return getPaymentState(text)}
                },{
                    title: '是否特批',
                    dataIndex: 'approval',
                    key: 'approval',
                    render:text=>{return text==2?'已特批':'未特批'}
                },{
                    title: '订单负责人',
                    dataIndex: 'salesmanName',
                    key: 'salesmanName',
                }
            ],
            dataSource: [],
        };
    },
    //操作分配
    confirmDelet(index){
    	this.setState({
    		userDetaile:false,
    	});
    	this.contactList(1,index.id)
    },
    //驳回
    reject(record){
    	let api ='api/bohui'
    	this.confirmSelect(api,record)
    },
    //确认
    confirm(record){
    	let api='api/quren'
    	this.confirmSelect(api,record)
    },
    confirmSelect(api,record){
    	this.setState({
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + api,
            data: {
            	id:record.id,
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('操作成功');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    componentWillMount() {
        this.departmentList();
    },
    tableRowClick(record, index) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    searchSwitch() {
		this.setState({
			searchMore: !this.state.searchMore
		});
	},
    search() {
        this.loadData();
    },
    //分配时搜索
    searchOrder() {
        this.contactList();
    },
    //分配时重置
    resetOrder() {
        this.contactList();
    },
    reset() {
    	this.state.buyerNameSearch='';
    	this.state.releaseDate[0] = undefined;
		this.state.releaseDate[1] = undefined;
		this.state.orderChannelSearch = undefined;
		this.state.liquidationStatusSearch = undefined;
		this.state.salesmanNameSearch = undefined;
		this.state.departmenttSearch = undefined;
		this.state.approved = undefined;
		this.state.orderChannel = undefined;
        this.loadData();       
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
        let departmentArr = this.state.departmentArr || [];
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>我的结算订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.buyerNameSearch}
	                        onChange={(e) => { this.setState({ buyerNameSearch: e.target.value }); }} />
	                    <RangePicker
		                        value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
		                        this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
		                        onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} /> 
                        <Select placeholder="部门机构"
	                        style={{ width: 150 ,marginRight:'10px',marginLeft:'10px'}}
	                        value={this.state.departmenttSearch}
	                        onChange={(e) => { this.setState({ departmenttSearch: e }) }}>
	                        {
	                            departmentArr.map(function (item) {
	                                    return <Select.Option key={item.id} >{item.name}</Select.Option>
	                            })
	                        }
                  		</Select>
                  		<Input placeholder="订单负责人" style={{width:'150px'}}
	                        value={this.state.salesmanNameSearch}
	                        onChange={(e) => { this.setState({ salesmanNameSearch: e.target.value }); }} />
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索</Button>
	                    <Button onClick={this.reset}>重置</Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}> 
	                        <Select placeholder="结算状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.liquidationStatusSearch}
	                            onChange={(e) => { this.setState({ liquidationStatusSearch: e }) }}>
	                            {
                                    paymentState.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="是否特批"
	                            style={{ width: 150,marginRight:'10px' }}
	                            value={this.state.orderChannelSearch}
	                            onChange={(e) => { this.setState({ orderChannelSearch: e }) }}>
	                            <Select.Option value='0'>未特批</Select.Option>
	                            <Select.Option value='1'>已特批</Select.Option>
	                        </Select>
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick} />
	                    </Spin>
	                </div>
	                <MySettlementDetaile
	                	confirmDelet={this.confirmDelet}
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
            </div>
        );
    }
}));

export default MySettlement;

